package org.openxma.dsl.dom.parsetree.reconstr;

import java.io.IOException;

import org.eclipse.xtext.parsetree.AbstractNode;
import org.eclipse.xtext.parsetree.LeafNode;
import org.eclipse.xtext.util.TextLocation;

public class DomDslParsetreeConstructorPatched extends
		org.openxma.dsl.dom.parseTreeConstruction.DomDslParsetreeConstructor {
	
	protected void write(AbstractToken token, WsMergerStream out, TextLocation location) throws IOException {
		AbstractNode node = token.getNode();
		if (node != null) {
			location.merge(node.getOffset(), node.getLength());
		}
		if (!token.getTokensForSemanticChildren().isEmpty())
			for (AbstractToken t : token.getTokensForSemanticChildren())
				write(t, out, location);
		else {
			if (token instanceof CommentToken)
				out.writeComment((LeafNode) node);
			else {
				String val = token.serialize(node);
				if (val != null || token instanceof ActionToken) {
					if (token instanceof AssignmentToken)
						out.writeSemantic(((AssignmentToken) token).getAssignmentElement(), val, node);
					else
						out.writeSemantic(token.getGrammarElement(), val, node);
				}
			}
		}
	}

}
